#include <iostream>

using namespace std;

int main()
{
    int n, m, k, Ai, Bi, i, j;
    int broj_boja=0;
    cin >> n >> m >> k;
    int tabla[n][m];
    for (i=0;i<k;++i)
    {
        cin >> Ai >> Bi;
        tabla[Ai][Bi]=-1;
    }
    for(i=0;i<n;i++)
    {
        for(j=0;j<m;++j)
        {
            if(broj_boja==0 && tabla[i][j]!=-1)
            {
                broj_boja++;
                tabla[i][j]=broj_boja;
                continue;
            }
            if(tabla[i][j]!=-1 && i>0)
            {
                if(tabla[i-1][j]>0)
                {
                    tabla[i][j]=tabla[i-1][j];
                }
                else if(tabla[i][j-1]>0 && j>0)
                {
                    {
                        tabla[i][j]=tabla[i-1][j];
                    }
                }
                else
                {
                    broj_boja++;
                    tabla[i][j]=broj_boja;
                }
            }
        }
    }
    cout << broj_boja;
    return 0;
}